---
id: 6668374ed18b7fce10259cb3
title: Step 37
challengeType: 20
dashedName: step-37
---

# --description--

Now that you have an idea of how the attribute access work, remove the last two lines of your code together with the `__getattr__` method.

Then, restore the `print()` calls you commented out before and delete the second argument from both of them.

# --hints--

You should not have a `__getattr__` method.

```js
({ test: () => assert.isFalse(runPython(`_Node(_code).find_class("R2Vector").has_function("__getattr__")`)) })
```

You should not have `print(v1.z)`and `print(getattr(v1, 'z'))` in your code.

```js
({ test: () => assert.isFalse(runPython(`
n = _Node(_code)
n.has_call("print(v1.z)") or n.has_call("print(getattr(v1, 'z'))")
`)) })
```

You should restore the `print()` calls you commented out before and remove the second argument from both of them.

```js
({ test: () => assert(runPython(`
_Node(_code).has_call("print(f'v1 = {v1}')") and _Node(_code).has_call("print(f'v2 = {v2}')")
`)) })
```

# --seed--

## --seed-contents--

```py
class R2Vector:
    def __init__(self, *, x, y):
        self.x = x
        self.y = y

    def norm(self):
        return sum(val**2 for val in vars(self).values())**0.5

    def __str__(self):
        return str(tuple(getattr(self, i) for i in vars(self)))

    def __repr__(self):
        arg_list = [f'{key}={val}' for key, val in vars(self).items()]
        args = ', '.join(arg_list)
        return f'{self.__class__.__name__}({args})'
--fcc-editable-region--
    def __getattr__(self, attr):                
        return 'calling __getattr__'
        
class R3Vector(R2Vector):
    def __init__(self, *, x, y, z):
        super().__init__(x=x, y=y)
        self.z = z

v1 = R2Vector(x=2, y=3)
v2 = R3Vector(x=2, y=2, z=3)
# print(f'v1 = {v1}', f'\nrepr = {repr(v1)}')
# print(f'v2 = {v2}', f'\nrepr = {repr(v2)}')
print(v1.z)
print(getattr(v1, 'z'))
--fcc-editable-region--
```
